!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program Arare
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: arare.f90,v 1.10 2005/02/07 10:12:29 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!ϤϽవ̷.
!
!== Future Plans
!
                                                                 !=end

program arare
                                                                 !=begin
  !== Dependency
  use gt4_history
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use dc_message
  use debugset, only: debugset_init
  use gridset,  only: gridset_init, DimXMin, DimXMax, DimZMin, DimZMax, &
       &              RegZMin, RegZMax
  use fileset,  only: fileset_init, cfgfile, basicfile, distrbfile
  use timeset,  only: timeset_init, NstepShort, NstepLong, &
       &              DelTimeShort, DelTimeLong, TimeDisp
  use expname,  only: expname_init
  use linlib,   only: linlib_init
  use bcset,    only: bcset_init
  use basicset, only: basicset_init
  use distrbset,only: distrbset_init
  use arareprm, only: arareprm_init 
                                                                 !=end
  implicit none

  real(8), allocatable  :: ss_Exner_as(:,:)
  real(8), allocatable  :: fs_VelX_as(:,:)
  real(8), allocatable  :: sf_VelZ_as(:,:)
  real(8), allocatable  :: ss_Exner_ns(:,:)
  real(8), allocatable  :: fs_VelX_ns(:,:)
  real(8), allocatable  :: sf_VelZ_ns(:,:)

  real(8), allocatable  :: ss_DivVel_ns(:,:)
  real(8), allocatable  :: fs_ForceVelX_nl(:,:)
  real(8), allocatable  :: sf_ForceVelZ_nl(:,:)
  
  real(8), allocatable  :: ss_PotTemp_bl(:,:)
  real(8), allocatable  :: ss_Exner_bl(:,:)
  real(8), allocatable  :: fs_VelX_bl(:,:)
  real(8), allocatable  :: sf_VelZ_bl(:,:)
  real(8), allocatable  :: ss_PotTemp_nl(:,:)
  real(8), allocatable  :: ss_Exner_nl(:,:)
  real(8), allocatable  :: fs_VelX_nl(:,:)
  real(8), allocatable  :: sf_VelZ_nl(:,:)
  real(8), allocatable  :: ss_PotTemp_al(:,:)
  real(8), allocatable  :: ss_Exner_al(:,:)
  real(8), allocatable  :: fs_VelX_al(:,:)
  real(8), allocatable  :: sf_VelZ_al(:,:)

  real(8), allocatable  :: ss_Km_bl(:,:)
  real(8), allocatable  :: ss_Km_nl(:,:)
  real(8), allocatable  :: ss_Km_al(:,:)
  real(8), allocatable  :: ss_Kh_bl(:,:)
  real(8), allocatable  :: ss_Kh_nl(:,:)
  real(8), allocatable  :: ss_Kh_al(:,:)

  real(8)               :: Time
  integer               :: t, tau

  type(gt_history)      :: ss_reg, fs_reg, sf_reg
  type(gt_history)      :: ss_dim, fs_dim, sf_dim
  

!!!
!!!
!!!
  !--- I/O ե̾ν
  call fileset_init

  !--- ǥХν
  call debugset_init(cfgfile)

  !--- ʻν
  call gridset_init(cfgfile)
  
  !--- ʬν
  call timeset_init(cfgfile)
  
  !--- ¸̾ν
  call expname_init(cfgfile)
  
  !--- ׻ɤ߹
  call arareprm_init(cfgfile)

  !--- 
  call bcset_init(cfgfile)

  !--- ܾͤ
  call basicset_init(basicfile)

  !--- ͤ
  call distrbset_init(distrbfile)
  
  !--- ׻饤֥ν. 
  !--- ϥ顼 z η׻ΰ礭
  call linlib_init(cfgfile, RegZMax - RegZMin)
  
  !--- ϥե
  call ArareOpenRegFile
  call ArareOpenDimFile

!!!
!!! CFL Υå
!!!
  call cflchk


!!!
!!!ѿν
!!!  
  !--- γ, 
  call ArareAlloc


!!!
!!!ʬ
!!!
  !--- ֤ե
  Time = 0.0d0
  call ArareOutputRegFile
  call ArareOutputDimFile
  
  !--- Ĺ֥ƥå
  !--- 1 ƥåܤ Euler 
  Time = Time + DelTimeLong
     
  !--- Ǵ, Ȼη׻
  call EddyViscosity(fs_VelX_bl, sf_VelZ_bl, ss_PotTemp_bl, &
       & ss_Km_bl, ss_Kh_bl)    
  ss_Km_al = ss_Km_bl; ss_Km_nl = ss_Km_bl
  ss_Kh_al = ss_Kh_bl; ss_Kh_nl = ss_Kh_bl
  
  !--- Ĺ֥ƥåפΰή, Ȼ, ǴȻ, Ǵη׻
  call ArareMomentumTimeLong( &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, &
       & fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, &
       & fs_ForceVelX_nl, sf_ForceVelZ_nl )
  
  !--- Ĺ֥ƥåפǤΥ顼̤η׻
  call ArarePotTempTimeLong( Time, &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, &
       & ss_PotTemp_bl, ss_Kh_bl, &
       & ss_PotTemp_al )
  
  !--- ûॹƥåפνͤ
  call ArareVariableTimeShort( Time )
     
  !--- ûॹƥåפǤʬ
  do tau = 1, NstepShort / 2
     call ArareMomentumTimeShort( &
          & fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
          & fs_ForceVelX_nl, sf_ForceVelZ_nl,               &
          & fs_VelX_as, sf_VelZ_as, ss_Exner_as )
     
     !--- 롼פ󤹤ν
     call ArareLoopTimeShort
  end do
  
  !--- ǽŪ®٤Ĺ֥ƥåפǤΤΤȤߤʤ
  call ArareVariableTimeLong
  
  !--- 롼פ󤹤ν
  call ArareLoopTimeLong
  
  !--- ե
  if ( mod( Time, TimeDisp ) == 0 ) then 
     call DbgMessage(fmt="Time = %f", d=(/Time/))
     call ArareOutputRegFile
     call ArareOutputDimFile
  end if
  
  
  !--- Ĺ֥ƥå
  !--- 2 ƥåܰʹߤ leap-frog 
  do t = 2, NstepLong 
     Time = Time + DelTimeLong
     write(*,*) Time
     
     !--- Ǵ, Ȼη׻
     call ArareEddyViscosity(                                &
          & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,                &
          & fs_VelX_bl, sf_VelZ_bl, ss_PotTemp_bl, ss_Km_bl, &
          & ss_Km_al, ss_Kh_al )
    
     !--- Ĺ֥ƥåפΰή, Ȼ, ǴȻ, Ǵη׻
     call ArareMomentumTimeLong( &
          & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, &
          & fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, &
          & fs_ForceVelX_nl, sf_ForceVelZ_nl )

     !--- Ĺ֥ƥåפǤΥ顼̤η׻
     call ArarePotTempTimeLong( Time, &
          & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, &
          & ss_PotTemp_bl, ss_Kh_bl, &
          & ss_PotTemp_al )
     
     !--- ûॹƥåפνͤ
     call ArareVariableTimeShort( Time )

     !--- ûॹƥåפǤʬ
     do tau = 1, NstepShort
        call ArareMomentumTimeShort( &
             & fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
             & fs_ForceVelX_nl, sf_ForceVelZ_nl,               &
             & fs_VelX_as, sf_VelZ_as, ss_Exner_as )
        
        !--- 롼פ󤹤ν
        call ArareLoopTimeShort
     end do
     
     !--- ǽŪ®٤Ĺ֥ƥåפǤΤΤȤߤʤ
     call ArareVariableTimeLong
     
     !--- åλ֥ե륿
     call ArareTimeFilter

     !--- 롼פ󤹤ν
     call ArareLoopTimeLong

     !--- ե
     if ( mod( Time, TimeDisp ) == 0 ) then 
        call DbgMessage(fmt="Time = %f", d=(/Time/))
        call ArareOutputRegFile
        call ArareOutputDimFile
     end if
     
  end do
  
  !--- ϥեΥ
  call ArareCloseRegFile
  call ArareCloseDimFile
  
  
contains

!!!
!!!ûॹƥåפǷ׻ͤĹॹƥåפǤͤ
!!!
  subroutine ArareVariableTimeLong
    ss_Exner_al  = ss_Exner_as 
    fs_VelX_al   = fs_VelX_as
    sf_VelZ_al   = sf_VelZ_as     
  end subroutine ArareVariableTimeLong


!!!
!!!ĹॹƥåפǷ׻ͤûॹƥåפǤͤ
!!!
  subroutine ArareVariableTimeShort( Time )
    use timeset, only: DelTimeLong

    real(8), intent(in) :: Time

    call BeginSub("ArareVariableTimeShort", &
&                fmt="Time = %f, %c",       &
&                d=(/Time/),  &
&                c1="Initialize variables for integration by short time step.")

    if ( Time == DelTimeLong ) then 
       fs_VelX_ns  = fs_VelX_nl
       sf_VelZ_ns  = sf_VelZ_nl
       ss_Exner_ns = ss_Exner_nl 
    else
       fs_VelX_ns  = fs_VelX_bl
       sf_VelZ_ns  = sf_VelZ_bl
       ss_Exner_ns = ss_Exner_bl 
    end if

    call EndSub("ArareVariableTimeShort")

  end subroutine ArareVariableTimeShort
  
  
!!!
!!!Ĺ֥ƥåפη׻ǤΥ롼פ󤹤
!!!
  subroutine ArareLoopTimeLong

    call BeginSub("ArareLoopTimeLong", &
&                 "%c",                &
&         c1="Replace variables for time integration by using long time step.")

    ss_PotTemp_bl = ss_PotTemp_nl
    ss_Exner_bl   = ss_Exner_nl 
    fs_VelX_bl    = fs_VelX_nl
    sf_VelZ_bl    = sf_VelZ_nl
    ss_Km_bl      = ss_Km_nl
    ss_Kh_bl      = ss_Kh_nl
    ss_PotTemp_nl = ss_PotTemp_al
    ss_Exner_nl   = ss_Exner_al 
    fs_VelX_nl    = fs_VelX_al
    sf_VelZ_nl    = sf_VelZ_al
    ss_Km_nl      = ss_Km_al
    ss_Kh_nl      = ss_Kh_al

    call EndSub("ArareLoopTimeLong")

  end subroutine ArareLoopTimeLong


!!!
!!!û֥ƥåפη׻ǤΥ롼פ󤹤
!!!
  subroutine ArareLoopTimeShort

    call BeginSub("ArareLoopTimeShort", &
&                 "%c",                 &
&        c1="Replace variables for time integration by using short time step.")

    ss_Exner_ns  = ss_Exner_as 
    fs_VelX_ns   = fs_VelX_as
    sf_VelZ_ns   = sf_VelZ_as

    call EndSub("ArareLoopTimeShort")

  end subroutine ArareLoopTimeShort
  

!!!
!!!åλ֥ե륿
!!!
  subroutine ArareTimeFilter

    call BeginSub("ArareTimeFilter", &
&                 fmt="%c",          &
&                 c1="Asselin time filter for leapfrog scheme is adapted.")

    call AsselinTimeFilter(ss_PotTemp_al, ss_PotTemp_nl, ss_PotTemp_bl )
    call AsselinTimeFilter(ss_Exner_al,   ss_Exner_nl,   ss_Exner_bl )
    call AsselinTimeFilter(fs_VelX_al,    fs_VelX_nl,    fs_VelX_bl )
    call AsselinTimeFilter(sf_VelZ_al,    sf_VelZ_nl,    sf_VelZ_bl )

    call EndSub("ArareTimeFilter")

  end subroutine ArareTimeFilter

  
!!!
!!!ûॹƥåפǤ u, w, pi η׻
!!!
  subroutine ArareMomentumTimeShort( fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
       & fs_ForceVelX_nl, sf_ForceVelZ_nl,                              &
       & fs_VelX_as, sf_VelZ_as, ss_Exner_as )

    use bcset, only: fs_BC, sf_BC, ss_BC

    implicit none
    real(8), intent(in)  :: fs_VelX_ns(:,:)
    real(8), intent(in)  :: sf_VelZ_ns(:,:)
    real(8), intent(in)  :: ss_Exner_ns(:,:)
    real(8), intent(in)  :: fs_ForceVelX_nl(:,:)
    real(8), intent(in)  :: sf_ForceVelZ_nl(:,:)
    real(8), intent(out) :: fs_VelX_as(:,:)
    real(8), intent(out) :: sf_VelZ_as(:,:)
    real(8), intent(out) :: ss_Exner_as(:,:)
    
    !--- ѿ
    real(8) ::  fs_PresGradVelX_ns(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) ::  sf_PresGradVelZ_as(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) ::  fs_ForceVelX_ns(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) ::  sf_ForceVelZ_as(DimXMin:DimXMax, DimZMin:DimZMax)

    call BeginSub("ArareMomentumTimeShort", & 
&                 fmt="%c",                 &
&                 c1="Time integration of acoustic wave component.")


    !--- ®٤μ«
    call DivergenceVel(fs_VelX_ns, sf_VelZ_ns, ss_DivVel_ns)
    
    !--- ® u η׻ (Ϸ٤ʺʬɾ)
    call PressureGradVelX(ss_Exner_ns, ss_DivVel_ns, &
         &               fs_PresGradVelX_ns)    
    
    fs_ForceVelX_ns = fs_PresGradVelX_ns + fs_ForceVelX_nl 

    call Integral(fs_ForceVelX_ns, DelTimeShort, fs_VelX_ns, fs_VelX_as)
    call boundary(fs_BC, fs_VelX_as)
    
    
    !--- ʡؿη׻ (ˡ)
    call Exner_HeVi( ss_DivVel_ns, sf_ForceVelZ_nl, fs_VelX_as, &
         &           sf_VelZ_ns, ss_Exner_ns, ss_Exner_as)
    call boundary(ss_BC, ss_Exner_as)
    

    !--- ® w η׻ (Ϸ٤ϸູʬɾ)
    call PressureGradVelZ(ss_Exner_ns, ss_Exner_as, ss_DivVel_ns, &
         &                sf_PresGradVelZ_as)

    sf_ForceVelZ_as = sf_PresGradVelZ_as + sf_ForceVelZ_nl 

    call Integral(sf_ForceVelZ_as, DelTimeShort, sf_VelZ_ns, sf_VelZ_as)
    call boundary(sf_BC, sf_VelZ_as)

    call EndSub("ArareMomentumTimeShort")

  end subroutine ArareMomentumTimeShort


!!!
!!!Ĺॹƥåפˤưή, Ϲ, ǴȻ, Ǵɾ
!!!
  subroutine ArareMomentumTimeLong( &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl,  &
       & fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, &
       & fs_ForceVelX_nl, sf_ForceVelZ_nl)
    
    use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax
    use timeset, only: DelTimeLong
    use bcset,   only: ss_BC

    implicit none
    real(8), intent(in)  :: fs_VelX_nl(:,:)
    real(8), intent(in)  :: sf_VelZ_nl(:,:)
    real(8), intent(in)  :: ss_PotTemp_nl(:,:)
    real(8), intent(in)  :: fs_VelX_bl(:,:)
    real(8), intent(in)  :: sf_VelZ_bl(:,:)
    real(8), intent(in)  :: ss_Km_bl(:,:)
    real(8), intent(out) :: fs_ForceVelX_nl(:,:)
    real(8), intent(out) :: sf_ForceVelZ_nl(:,:)
    
    real(8)  :: fs_AdvVelX_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: sf_AdvVelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: sf_Buoy_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: fs_TurbVelX_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: sf_TurbVelZ_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: fs_NumDiffVelX_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: sf_NumDiffVelZ_bl(DimXMin:DimXMax, DimZMin:DimZMax)

    call BeginSub("ArareMomentumTimeLong", &
&                 "%c",                    &
&                  c1="Time integration of advection component.")

    !--- ή
    call AdvectVelX(fs_VelX_nl, sf_VelZ_nl, fs_AdvVelX_nl)
    call AdvectVelZ(fs_VelX_nl, sf_VelZ_nl, sf_AdvVelZ_nl)

    !--- Ϲ 
    call  Buoyancy(ss_PotTemp_nl, sf_Buoy_nl)
    
    !--- ήȻ ( t - t ɾ)
    call TurbulenceVelX(fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, fs_TurbVelX_bl)
    call TurbulenceVelZ(fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, sf_TurbVelZ_bl)
    
    !--- Ǵ ( t - t ɾ)
    call NumDiffusionVelX(fs_VelX_bl, fs_NumDiffVelX_bl)
    call NumDiffusionVelZ(sf_VelZ_bl, sf_NumDiffVelZ_bl)
    
    !--- ޤȤƽ
    fs_ForceVelX_nl = &
         & - fs_AdvVelX_nl + fs_TurbVelX_bl + fs_NumDiffVelX_bl 
    sf_ForceVelZ_nl = &
         & - sf_AdvVelZ_nl + sf_TurbVelZ_bl + sf_NumDiffVelZ_bl + sf_Buoy_nl

    call EndSub("ArareMomentumTimeLong")
    
  end subroutine ArareMomentumTimeLong

!!!
!!!ĹॹƥåפǤΥ顼̤η׻
!!!
  subroutine ArarePotTempTimeLong( Time, &
       & fs_VelX_nl, sf_VelZ_nl, ss_Scalar_nl, &
       & ss_Scalar_bl, ss_Kh_bl,  &
       & ss_Scalar_al)
    
    use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax
    use timeset, only: DelTimeLong
    use bcset,   only: ss_BC
    use differentiate, only: sf_dz_ss
    use average,       only: ss_avr_sf
    use basicset,      only: ss_PotTempBasicZ

    implicit none
    real(8), intent(in)  :: Time
    real(8), intent(in)  :: fs_VelX_nl(:,:)
    real(8), intent(in)  :: sf_VelZ_nl(:,:)
    real(8), intent(in)  :: ss_Scalar_nl(:,:)
    real(8), intent(in)  :: ss_Scalar_bl(:,:)
    real(8), intent(in)  :: ss_Kh_bl(:,:)
    real(8), intent(out) :: ss_Scalar_al(:,:)

    !--- ѿ
    real(8)  :: ss_AdvScalar_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_SrcScalar_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_TurbScalar_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_NumDiffScalar_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_ForceScalar_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: DelTime

    call BeginSub("ArarePotTempTimeLong", &
&                 fmt="%c",              &
&                 c1="Time integration of scalar component.")

    !--- ή
    call AdvectScalar(fs_VelX_nl, sf_VelZ_nl, ss_Scalar_nl, &
         &             ss_AdvScalar_nl)

    !--- 
    ss_SrcScalar_nl = ss_avr_sf( sf_VelZ_nl * sf_dz_ss( ss_PotTempBasicZ ) ) 

    !--- ήȻ ( t - t ɾ)
    call TurbulenceScalar(ss_Scalar_bl, ss_Kh_bl, ss_TurbScalar_bl)
    
    !--- Ǵ ( t - t ɾ)
    call NumDiffusionScalar(ss_Scalar_bl, ss_NumDiffScalar_bl)
    
    !--- ޤȤ
    ss_ForceScalar_nl = &
         & - ss_AdvScalar_nl  - ss_SrcScalar_nl &
         & + ss_TurbScalar_bl + ss_NumDiffScalar_bl 
    
    !--- ̤λʬ
    if ( Time == DelTimeLong ) then 
       DelTime = DelTimeLong
       call Integral(ss_ForceScalar_nl, DelTime, ss_Scalar_nl, ss_Scalar_al)
    else
       DelTime = 2.0 * DelTimeLong
       call Integral(ss_ForceScalar_nl, DelTime, ss_Scalar_bl, ss_Scalar_al)
    end if
    
    !--- 
    call boundary(ss_BC, ss_Scalar_al)
    
    call EndSub("ArarePotTempTimeLong")
    
  end subroutine ArarePotTempTimeLong


!!!
!!!ήͥ륮λȯŸ
!!!
  subroutine ArareEddyViscosity( &
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,                &
       & fs_VelX_bl, sf_VelZ_bl, ss_PotTemp_bl, ss_Km_bl, &
       & ss_Km_al, ss_Kh_al )
    
    use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
    use timeset,  only: DelTimeLong
    use bcset,    only: ss_BC

    implicit none
    real(8), intent(in)  :: fs_VelX_nl(:,:)
    real(8), intent(in)  :: sf_VelZ_nl(:,:)
    real(8), intent(in)  :: ss_Km_nl(:,:)
    real(8), intent(in)  :: fs_VelX_bl(:,:)
    real(8), intent(in)  :: sf_VelZ_bl(:,:)
    real(8), intent(in)  :: ss_PotTemp_bl(:,:)
    real(8), intent(in)  :: ss_Km_bl(:,:)
    real(8), intent(out) :: ss_Km_al(:,:)
    real(8), intent(out) :: ss_Kh_al(:,:)
    
    real(8)  :: ss_AdvKm_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_BuoyKm_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_DivVel_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_ShearKm_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_DiffKm_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_DispKm_bl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_ForceKm_nl(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: DelTime
    

    !--- ή
    call AdvectScalar(fs_VelX_nl, sf_VelZ_nl, ss_Km_nl, &
         &             ss_AdvKm_nl)

    !--- Ϥˤήͥ륮
    call SubGridBuoy(ss_PotTemp_bl, ss_BuoyKm_bl) 

    !--- ˤήͥ륮
    call DivergenceVel( fs_VelX_bl, sf_VelZ_bl, ss_DivVel_bl )
    call SubGridShear( fs_VelX_bl, sf_VelZ_bl, ss_DivVel_bl, ss_Km_bl, &
         &             ss_ShearKm_bl )
    
    !--- ήͥ륮γȻ
    call SubGridDiff( ss_Km_bl, ss_DiffKm_bl )
       
    !--- ήͥ륮ξû
    call SubGridDisp( ss_Km_bl, ss_DispKm_bl )    

    !--- ޤȤ
    ss_ForceKm_nl = - ss_AdvKm_nl  - ss_BuoyKm_bl  +  ss_ShearKm_bl &
         &          + ss_DiffKm_bl - ss_DispKm_bl 
    
    !--- ʬ
    DelTime = 2.0 * DelTimeLong
    call Integral(ss_ForceKm_nl, DelTime, ss_Km_bl, ss_Km_al)

    !--- 
    call boundary(ss_BC, ss_Km_al)

    !--- ΰ˸
    where ( ss_Km_al < 0.0d0 )
       ss_Km_al = 0.0d0
    end where
    
    !--- Ȼ
    ss_Kh_al = 3.0d0 * ss_Km_al
    
  end subroutine ArareEddyViscosity


!!!
!!!γ, 
!!!
  subroutine ArareAlloc
    use distrbset, only: fs_VelXDistrb, sf_VelZDistrb, &
         &               ss_ExnerDistrb, ss_PotTempDistrb

    call BeginSub("ArareAlloc", &
&                 fmt="%c",     &
&                 c1="Allocate and initialize allocatable variables.")

    allocate(ss_Exner_as(DimXMin:DimXMax, DimZMin:DimZMax),  &
         & fs_VelX_as(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & sf_VelZ_as(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_ForceVelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_ForceVelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_DivVel_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_al(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_al = 0.0d0
    fs_VelX_nl = 0.0d0
    fs_VelX_bl = 0.0d0

    sf_VelZ_al = 0.0d0
    sf_VelZ_nl = 0.0d0
    sf_VelZ_bl = 0.0d0

    ss_Exner_al = 0.0d0
    ss_Exner_nl = 0.0d0
    ss_Exner_bl = 0.0d0
    
    ss_PotTemp_al = 0.0d0
    ss_PotTemp_nl = 0.0d0
    ss_PotTemp_bl = 0.0d0

    fs_VelX_as = 0.0d0
    fs_VelX_ns = 0.0d0

    sf_VelZ_as = 0.0d0
    sf_VelZ_ns = 0.0d0

    ss_Exner_as = 0.0d0
    ss_Exner_ns = 0.0d0

    fs_ForceVelX_nl = 0.0d0
    sf_ForceVelZ_nl = 0.0d0

    ss_DivVel_ns = 0.0d0

    ss_Km_bl = 0.0d0
    ss_Km_nl = 0.0d0
    ss_Km_al = 0.0d0
    ss_Kh_bl = 0.0d0
    ss_Kh_nl = 0.0d0
    ss_Kh_al = 0.0d0

    !®پν
    fs_VelX_bl = fs_VelXDistrb
    fs_VelX_nl = fs_VelXDistrb
    sf_VelZ_bl = sf_VelZDistrb
    sf_VelZ_nl = sf_VelZDistrb

    !̵Ϥν
    ss_Exner_bl = ss_ExnerDistrb
    ss_Exner_nl = ss_ExnerDistrb

    !̤ν
    ss_PotTemp_bl = ss_PotTempDistrb
    ss_PotTemp_nl = ss_PotTempDistrb

    call EndSub("ArareAlloc")

  end subroutine ArareAlloc


!!!
!!!ϥե. ׻ΰΤ
!!! 
  subroutine ArareOpenRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax, &
         & NX, NZ, f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_RegFile, sf_RegFile, ss_RegFile

    call BeginSub("ArareOpneRegFile", &
&                 fmt="%c",           &
&                 c1="Initialize output file name and variables in physical region.")
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/NX+1, NZ, 0/),                       &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_reg)
    
    ! ѿ
    call HistoryPut('x', f_X(RegXMin: RegXMax), fs_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), fs_reg)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/NX, NZ+1, 0/),                       &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), sf_reg)
    call HistoryPut('z', f_Z(RegXMin: RegXMax), sf_reg)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_RegFile,                            &         
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z','t'/),                         &
         & dimsizes=(/NX, NZ, 0/),                       &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate',                   &
         &             'Time        '/),                 &
         & units=(/'m','m','s'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), ss_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), ss_reg)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z','t'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    ! 
    call HistoryAddVariable(                            &
         & varname='PotTemp', dims=(/'x','z','t'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                 & 
         & history = ss_reg)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z','t'/),             &
         & longname='zonal velocity',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z','t'/),             &
         & longname='vertical velocity',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    
    ! Ǵ
    call HistoryAddVariable(                            &
         & varname='Km', dims=(/'x','z','t'/),             &
         & longname='Km',         &
         & units='1', xtype='double',                & 
         & history = ss_reg)    
    
    ! Ȼ
    call HistoryAddVariable(                            &
         & varname='Kh', dims=(/'x','z','t'/),             &
         & longname='Kh',         &
         & units='1', xtype='double',                & 
         & history = ss_reg)    

    call EndSub("ArareOpneRegFile")
    
  end subroutine ArareOpenRegFile


!!!
!!!ե. Ĺ֥ƥåפǽ. ׻ΰΤ
!!!
  subroutine ArareOutputRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax

    call BeginSub("ArareOutputRegFile", &
&                 fmt="%c",             &
&                 c1="Output variables in physical region.")

    call HistoryPut('t', Time, ss_reg)
    call HistoryPut('t', Time, fs_reg)
    call HistoryPut('t', Time, sf_reg)

    call HistoryPut('Exner', &
         & ss_Exner_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('PotTemp', &
         & ss_PotTemp_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('Km', &
         & ss_Km_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('Kh', &
         & ss_Kh_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('VelX', &
         & fs_VelX_nl(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('VelZ', &
         & sf_VelZ_nl(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)

    call EndSub("ArareOutputRegFile")

  end subroutine ArareOutputRegFile


!!!
!!!ϥեΥ. ׻ΰΤ
!!!  
  subroutine ArareCloseRegFile

    call BeginSub("ArareCloseRegFile", &
&                 fmt="%c", &
&                 c1="Close output file name for physical region.")

    call HistoryClose( ss_reg )
    call HistoryClose( fs_reg )
    call HistoryClose( sf_reg )

    call EndSub("ArareCloseRegFile")

  end subroutine ArareCloseRegFile


!!!
!!!ϥե. ΰ
!!!
  subroutine ArareOpenDimFile
    use gridset, only: f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_DimFile, sf_DimFile, ss_DimFile

    integer::   N

    call BeginSub("ArareOpneDimFile", &
&                  fmt="%c",         &
&     c1="Initialize output file name and variables in all computational region.")

    N = size(f_X, 1)

    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/N, N, 0/),                           &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_dim)
    
    ! ѿ
    call HistoryPut('x', f_X, fs_dim)
    call HistoryPut('z', s_Z, fs_dim)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/N, N, 0/),                           &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, sf_dim)
    call HistoryPut('z', f_Z, sf_dim)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_DimFile,                            &
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z','t'/),                         &
         & dimsizes=(/N, N, 0/),                         &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate',                   &
         &             'Time        '/),                 &
         & units=(/'m','m','s'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, ss_dim)
    call HistoryPut('z', s_Z, ss_dim)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z','t'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    ! 
    call HistoryAddVariable(                            &
         & varname='PotTemp', dims=(/'x','z','t'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                   & 
         & history = ss_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z','t'/),        &
         & longname='zonal velocity',                   &
         & units='m/s', xtype='double',                 & 
         & history = fs_dim)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z','t'/),        &
         & longname='vertical velocity',                &
         & units='m/s', xtype='double',                 & 
         & history = sf_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='Km', dims=(/'x','z','t'/),        &
         & longname='Km',                &
         & units='1', xtype='double',                 & 
         & history = ss_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='Kh', dims=(/'x','z','t'/),        &
         & longname='Kh',                &
         & units='1', xtype='double',                 & 
         & history = ss_dim)    

    call EndSub("ArareOpneDimFile")

  end subroutine ArareOpenDimFile


!!!
!!!ե. Ĺ֥ƥåפͤ. ΰ
!!!
  subroutine ArareOutputDimFile

    call BeginSub("ArareOutputDimFile", &
&                 fmt="%c",            &
&                 c1="Output variables in all computational region.")

    call HistoryPut('t', Time, ss_dim)
    call HistoryPut('t', Time, fs_dim)
    call HistoryPut('t', Time, sf_dim)

    call HistoryPut('Exner', ss_Exner_nl, ss_dim)
    call HistoryPut('PotTemp', ss_PotTemp_nl, ss_dim)
    call HistoryPut('Km', ss_Km_nl, ss_dim)
    call HistoryPut('Kh', ss_Kh_nl, ss_dim)
    call HistoryPut('VelX',  fs_VelX_nl, fs_dim)
    call HistoryPut('VelZ',  sf_VelZ_nl, sf_dim)

    call EndSub("ArareOutputDimFile")

  end subroutine ArareOutputDimFile


!!!
!!!ϥեΥ. ΰ
!!!  
  subroutine ArareCloseDimFile

    call BeginSub("ArareCloseDimFile", &
&                 fmt="%c",            &
&                  c1="Close output file name for all computational region.")

    call HistoryClose( ss_dim )
    call HistoryClose( fs_dim )
    call HistoryClose( sf_dim )

    call EndSub("ArareCloseDimFile")

  end subroutine ArareCloseDimFile


end program arare
